#include "DxLib.h"
#include <math.h>

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow )
{
	int ModelHandle ;
	int PixelShaderHandle ;
	int VertexShaderHandle ;
	float LightRotateAngle ;

	// EChE[hŋN
	ChangeWindowMode( TRUE ) ;

	// cwCȕ
	if( DxLib_Init() < 0 )
	{
		// G[璼ɏI
		return -1 ;
	}

	// _VF[_[ǂݍ
	VertexShaderHandle = LoadVertexShader( "NormalMesh_PointLightVS.vso" ) ;

	// sNZVF[_[ǂݍ
	PixelShaderHandle = LoadPixelShader( "NormalMesh_PointLightPS.pso" ) ;

	// ̃bVfǂݍ
	ModelHandle = MV1LoadModel( "NormalBox.mqo" ) ;

	// `𗠉ʂɂ
	SetDrawScreen( DX_SCREEN_BACK ) ;

	// f̕`ɃIWiVF[_[gpݒnmɂ
	MV1SetUseOrigShader( TRUE ) ;

	// gp钸_VF[_[Zbg
	SetUseVertexShader( VertexShaderHandle ) ;

	// gpsNZVF[_[Zbg
	SetUsePixelShader( PixelShaderHandle ) ;

	// ώ@₷ʒuɃJړ
	SetCameraPositionAndTarget_UpVecY( VGet( 400.0f, 400.0f, -400.0f ), VGet( 0.0f, 0.0f, 0.0f ) ) ;

	// Cg̈ʒu]l
	LightRotateAngle = 0.0f ;

	// WCg̃^Cv|CgCgɂ
	ChangeLightTypePoint( VGet( 0.0f, 0.0f, 0.0f ), 700.0f, 0.391586f, 0.001662f, 0.0f ) ;

	// ESCL[܂Ń[v
	while( ProcessMessage() == 0 && CheckHitKey( KEY_INPUT_ESCAPE ) == 0 )
	{
		// ʂ
		ClearDrawScreen() ;

		// Cg̈ʒủ]lZ
		LightRotateAngle += 0.02f ;

		// Cg̈ʒu̍XV
		SetLightPosition( VGet( sin( LightRotateAngle ) * 400.0f, 200.0f, cos( LightRotateAngle ) * 400.0f ) ) ;

		// f`
		MV1DrawModel( ModelHandle ) ;

		// ʂ̓e\ʂɔf
		ScreenFlip() ;
	}

	// ǂݍ񂾒_VF[_[̍폜
	DeleteShader( VertexShaderHandle ) ;

	// ǂݍ񂾃sNZVF[_[̍폜
	DeleteShader( PixelShaderHandle ) ;

	// ǂݍ񂾃f̍폜
	MV1DeleteModel( ModelHandle ) ;

	// cwCǔn
	DxLib_End() ;

	// \tg̏I
	return 0 ;
}
